Index: LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/mod_xios_dyn3dmem.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/mod_xios_dyn3dmem.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/mod_xios_dyn3dmem.F90	(revision 4482)
@@ -29,4 +29,6 @@
      MODULE PROCEDURE writefield_dyn1d_v, writefield_dyn2d_v
   END INTERFACE writefield_dyn_v
+
+     REAL, ALLOCATABLE, SAVE :: NewField_U(:,:,:), NewField_V(:,:,:)
   
 
@@ -63,4 +65,11 @@
 ! 0 Initialisations
      pi = 4. * ATAN (1.)
+! allocation of fields passed to xios
+!$OMP BARRIER
+!$OMP MASTER
+     allocate(NewField_U(iip1, jj_begin:jj_end, llm))
+     allocate(NewField_V(iip1, jj_begin:jj_end, llm))     
+!$OMP END MASTER
+!$OMP BARRIER
 
 ! 1 Context initialisation
@@ -151,10 +160,17 @@
      CHARACTER(LEN=*)   :: name
      REAL, DIMENSION(ij_begin:ij_end,llm) :: Field
-     REAL, DIMENSION(iip1, jj_begin:jj_end,llm) :: NewField
+!     REAL, ALLOCATABLE, SAVE :: NewField(:,:,:)
      INTEGER :: i,j,l, count
 
-!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+!!!!!$OMP BARRIER
+!!!!!$OMP MASTER
+!!!!     allocate(NewField(iip1, jj_begin:jj_end, llm))
+!!!!!$OMP END MASTER
+!!!!!$OMP BARRIER
+
+
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
      DO l = 1, llm
-       NewField(:,jj_begin:jj_end,l)=reshape(Field(ij_begin:ij_end,l),(/iip1,jj_nb/))
+       NewField_U(:,jj_begin:jj_end,l)=reshape(Field(ij_begin:ij_end,l),(/iip1,jj_nb/))
      ENDDO
 !$OMP ENDDO
@@ -162,8 +178,8 @@
 
 !$OMP MASTER
-!!     write(14,*)'iip1,ij_begin,ij_end,llm,jj_begin,jj_end,jj_nb ',iip1,ij_begin,ij_end,llm,jj_begin,jj_end,jj_nb
-
-     CALL xios_send_field(name, NewField)
-!$OMP END MASTER   
+     CALL xios_send_field(name, NewField_U)
+!!!!     DEALLOCATE(NewField)
+!$OMP END MASTER   
+!$OMP BARRIER
   
    END SUBROUTINE  writefield_dyn2d_u
@@ -207,6 +223,12 @@
      CHARACTER(LEN=*)   :: name
      REAL, DIMENSION(ij_begin:ij_end,llm) :: Field
-     REAL, DIMENSION(iip1,  jj_begin:jj_end,llm) :: NewField
+!!!!     REAL, ALLOCATABLE, SAVE :: NewField(:,:,:)
      INTEGER :: l, jje, ije, jjn
+
+!!!!!$OMP BARRIER
+!!!!!$OMP MASTER
+!!!!     allocate(NewField(iip1,  jj_begin:jj_end,llm))
+!!!!!$OMP END MASTER
+!!!!!$OMP BARRIER
 
      IF (pole_sud) THEN
@@ -223,12 +245,14 @@
 !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
      DO l = 1, llm
-        NewField(:,jj_begin:jje,l)=reshape(Field(ij_begin:ije,l),(/iip1,jjn/))
+        NewField_V(:,jj_begin:jje,l)=reshape(Field(ij_begin:ije,l),(/iip1,jjn/))
      ENDDO
 !$OMP ENDDO
-
 !$OMP BARRIER       
-!$OMP MASTER
-     CALL xios_send_field(name, NewField(:,jj_begin:jje,:))
-!$OMP END MASTER   
+
+!$OMP MASTER
+     CALL xios_send_field(name, NewField_V(:,jj_begin:jje,:))
+!!!!     DEALLOCATE(NewField)
+!$OMP END MASTER   
+!$OMP BARRIER 
   
    END SUBROUTINE  writefield_dyn2d_v
Index: LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/parallel_lmdz.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/parallel_lmdz.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/parallel_lmdz.F90	(revision 4482)
@@ -676,5 +676,5 @@
         else
            write(lunout,*)ij  
-        stop 'erreur dans Gather_Field'
+        CALL abort_gcm("parallel_lmdz","erreur dans Gather_Field",1)
         endif
         
@@ -690,5 +690,5 @@
               Recv_count(i)=(min(jj_end_para(i),jjm)-jj_begin_para(i)+1)*ll*iip1
             else
-              stop 'erreur dans Gather_Field'
+              CALL abort_gcm("parallel_lmdz","erreur dans Gather_Field",1)
             endif
                    
Index: LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/qminimum_loc.F
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/qminimum_loc.F	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/qminimum_loc.F	(revision 4482)
@@ -55,4 +55,6 @@
 c
 
+c$OMP BARRIER
+
       !write(lunout,*) 'qminimum 52: entree'
       IF(first) THEN
@@ -66,10 +68,18 @@
       ije=ij_end
 
-      zx_defau_diag(ijb:ije,:,:)=0.0
-      q_follow(ijb:ije,:,1:2)=q(ijb:ije,:,1:2)  
+      DO k = 1, llm
+c$OMP DO SCHEDULE(STATIC)
+        DO i = ijb, ije
+          zx_defau_diag(i,k,1)=0.0
+          zx_defau_diag(i,k,2)=0.0
+          q_follow(i,k,1)=q(i,k,1)
+          q_follow(i,k,2)=q(i,k,2)
+        ENDDO
+c$OMP END DO NOWAIT
+      ENDDO
 
       !write(lunout,*) 'qminimum 57'
-c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)       
       DO 1000 k = 1, llm
+c$OMP DO SCHEDULE(STATIC)       
       DO 1040 i = ijb, ije
             if (seuil_liq - q(i,k,iq_liq) .gt. 0.d0 ) then
@@ -82,9 +92,6 @@
             endif
  1040 CONTINUE
+c$OMP END DO NOWAIT
  1000 CONTINUE
-c$OMP END DO NOWAIT
-c$OMP BARRIER
-c --->  SYNCHRO OPENMP ICI
-
 
 c
@@ -113,5 +120,4 @@
 c$OMP END DO NOWAIT
       ENDDO
-c$OMP BARRIER
 
 c
@@ -130,5 +136,5 @@
          ENDIF
       ENDDO
-c$OMP END DO  
+c$OMP END DO NOWAIT 
 !      pompe = SSUM(ije-ijb+1,zx_pump(ijb),1)
 
@@ -162,5 +168,5 @@
         endif !if (zx_pump(i).gt.0.0) then
       enddo !DO i = ijb, ije  
-c$OMP END DO
+c$OMP END DO NOWAIT
 
       ! 2) transfert de vap vers les couches plus hautes
@@ -206,5 +212,5 @@
                    write(*,*) 'q(i,k-1,iqIsoPha(ixt,iq_vap))=',
      :                   q(i,k-1,iqIsoPha(ixt,iq_vap))
-                   stop
+                CALL abort_gcm("qminimum_loc","stopped",1)
                 endif
               endif
@@ -231,5 +237,5 @@
                    write(*,*) 'q(i,k-1,iqIsoPha(ixt,iq_vap))=',
      :                   q(i,k-1,iqIsoPha(ixt,iq_vap))
-                   stop
+                   CALL abort_gcm("qminimum_loc","stopped",1)
                 endif
               endif 
@@ -243,5 +249,5 @@
           endif !if (zx_defau_diag(i,k,iq_vap).gt.0.0) then
         enddo !DO i = 1, ip1jmp1        
-c$OMP END DO
+c$OMP END DO NOWAIT
         enddo !do k=2,llm
 
@@ -272,5 +278,5 @@
           endif !if (zx_defau_diag(i,k,iq_vap).gt.0.0) then
         enddo !DO i = ijb, ije
-c$OMP END DO        
+c$OMP END DO NOWAIT       
        enddo !do k=2,llm  
 
@@ -279,4 +285,6 @@
       endif !if (niso > 0) then
       !write(*,*) 'qminimum 188'
+c$OMP BARRIER
+
 c
       RETURN
Index: LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/times.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/times.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/times.F90	(revision 4482)
@@ -55,5 +55,5 @@
     
       if (timer_state(no_timer)/=stopped) then
-        stop 'start_timer :: timer is already running or suspended'
+        CALL abort_gcm("times","start_timer :: timer is already running or suspended",1)
       else
         timer_state(no_timer)=running
@@ -73,5 +73,5 @@
     if (AllTimer_IsActive) then   
       if (timer_state(no_timer)/=running) then
-        stop 'suspend_timer :: timer is not running'
+         CALL abort_gcm("times","suspend_timer :: timer is not running",1)
       else
         timer_state(no_timer)=suspended
@@ -90,5 +90,5 @@
     if (AllTimer_IsActive) then   
       if (timer_state(no_timer)/=suspended) then
-        stop 'resume_timer :: timer is not suspended'
+        CALL abort_gcm("times","resume_timer :: timer is not suspended",1)
       else
         timer_state(no_timer)=running
@@ -110,5 +110,5 @@
        
       if (timer_state(no_timer)/=running) then
-        stop 'stop_timer :: timer is not running'
+        CALL abort_gcm("times","stop_timer :: timer is not running",1)
       else
         timer_state(no_timer)=stopped
Index: LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/vlsplt_loc.F
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/vlsplt_loc.F	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/vlsplt_loc.F	(revision 4482)
@@ -210,5 +210,4 @@
 c$OMP END DO NOWAIT
 #endif
-c	stop
 
 c	go to 9999
@@ -351,5 +350,5 @@
 c$OMP END DO NOWAIT
       enddo !do ifils=1,tracers(iq)%nqDescen
-      do ifils=1,tracers(iq)%nqChilds
+      do ifils=1,tracers(iq)%nqChildren
         iq2=tracers(iq)%iqDescen(ifils)
         call vlx_loc(Ratio,pente_max,masse,u_mq,ijb_x,ije_x,iq2)
@@ -726,5 +725,5 @@
 ! CRisi: appel récursif de l'advection sur les fils.
 ! Il faut faire ça avant d'avoir mis à jour q et masse
-      !write(*,*) 'vly 689: iq,nqChilds(iq)=',iq,tracers(iq)%nqChilds
+!     write(*,*)'vly 689: iq,nqChildren(iq)=',iq,tracers(iq)%nqChildren
 
       ijb=ij_begin-2*iip1
@@ -761,5 +760,5 @@
       enddo
 
-      do ifils=1,tracers(iq)%nqChilds
+      do ifils=1,tracers(iq)%nqChildren
         iq2=tracers(iq)%iqDescen(ifils)
         call vly_loc(Ratio,pente_max,masse,qbyv,iq2)
@@ -1148,5 +1147,5 @@
 ! CRisi: appel récursif de l'advection sur les fils.
 ! Il faut faire ça avant d'avoir mis à jour q et masse
-      !write(*,*) 'vlsplt 942: iq,nqChilds(iq)=',iq,tracers(iq)%nqChilds
+!     write(*,*)'vlsplt 942: iq,nqChildren(iq)=',iq,tracers(iq)%nqChildren
       do ifils=1,tracers(iq)%nqDescen
         iq2=tracers(iq)%iqDescen(ifils)
@@ -1169,5 +1168,5 @@
 c$OMP BARRIER
 
-      do ifils=1,tracers(iq)%nqChilds
+      do ifils=1,tracers(iq)%nqChildren
         iq2=tracers(iq)%iqDescen(ifils)
         call vlz_loc(Ratio,pente_max,masse,w,ijb_x,ije_x,iq2)
Index: LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/vlspltgen_loc.F
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/vlspltgen_loc.F	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/vlspltgen_loc.F	(revision 4482)
@@ -1,3 +1,4 @@
-!
+
+!     
 ! $Header$
 !
@@ -259,6 +260,5 @@
 c$OMP END MASTER 
           CASE DEFAULT
-          stop 'vlspltgen_p : schema non parallelise'
-      
+             CALL abort_gcm("vlspltgen_loc","schema non parallelise",1)
         END SELECT
       
@@ -302,6 +302,5 @@
 #endif    
           CASE DEFAULT
-          stop 'vlspltgen_p : schema non parallelise'
-      
+          CALL abort_gcm("vlspltgen_p","schema non parallelise",1)
         END SELECT
       
@@ -346,5 +345,5 @@
           CASE(14); call vlyqs_loc(zq,pente_max,zm,mv,qsat,iq)
           CASE DEFAULT
-          stop 'vlspltgen_p : schema non parallelise'
+          CALL abort_gcm("vlspltgen_p","schema non parallelise",1)
         END SELECT
        
@@ -392,7 +391,7 @@
 c$OMP BARRIER
           CASE DEFAULT
-          stop 'vlspltgen_p : schema non parallelise'
-      
-        END SELECT
+            
+            CALL abort_gcm("vlspltgen_p","schema non parallelise",1)
+         END SELECT
       
       enddo
@@ -429,5 +428,5 @@
 c$OMP BARRIER        
           CASE DEFAULT
-          stop 'vlspltgen_p : schema non parallelise'
+          CALL abort_gcm("vlspltgen_p","schema non parallelise",1)
         END SELECT
       
@@ -466,5 +465,6 @@
           CASE(10); call   vly_loc(zq,pente_max,zm,mv,     iq)
           CASE(14); call vlyqs_loc(zq,pente_max,zm,mv,qsat,iq)
-          CASE DEFAULT; stop 'vlspltgen_p : schema non parallelise'
+          CASE DEFAULT
+             CALL abort_gcm("vlspltgen_p","schema non parallelise",1)
         END SELECT
        
@@ -486,5 +486,6 @@
           CASE(14); call vlxqs_loc(zq,pente_max,zm,mu,
      &                 qsat, ij_begin,ij_end,iq)
-          CASE DEFAULT; stop 'vlspltgen_p : schema non parallelise'
+          CASE DEFAULT
+          CALL abort_gcm("vlspltgen_p","schema non parallelise",1)
         END SELECT
        
Index: LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/vlspltqs_loc.F
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/vlspltqs_loc.F	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/vlspltqs_loc.F	(revision 4482)
@@ -74,6 +74,4 @@
             DO ij=ijb,ije-1
                dxqu(ij)=q(ij+1,l,iq)-q(ij,l,iq)
-c              IF(u_m(ij,l).lt.0.) stop'limx n admet pas les U<0'
-c              sigu(ij)=u_m(ij,l)/masse(ij,l,iq)
             ENDDO
             DO ij=ijb+iip1-1,ije,iip1
@@ -337,6 +335,6 @@
 ! CRisi: appel recursif de l'advection sur les fils.
 ! Il faut faire ca avant d'avoir mis a jour q et masse
-      !write(*,*) 'vlspltqs 336: iq,ijb_x,nqChilds(iq)=',
-!     &     iq,ijb_x,tracers(iq)%nqChilds
+      !write(*,*) 'vlspltqs 336: iq,ijb_x,nqChildren(iq)=',
+!     &     iq,ijb_x,tracers(iq)%nqChildren
 
       do ifils=1,tracers(iq)%nqDescen
@@ -356,5 +354,5 @@
 c$OMP END DO NOWAIT
       enddo
-      do ifils=1,tracers(iq)%nqChilds
+      do ifils=1,tracers(iq)%nqChildren
         iq2=tracers(iq)%iqDescen(ifils)
         !write(*,*) 'vlxqs 349: on appelle vlx pour iq2=',iq2
@@ -729,5 +727,6 @@
 ! CRisi: appel recursif de l'advection sur les fils.
 ! Il faut faire ca avant d'avoir mis a jour q et masse
-      !write(*,*) 'vlyqs 689: iq,nqChilds(iq)=',iq,tracers(iq)%nqChilds
+!     write(*,*)'vlyqs 689: iq,nqChildren(iq)=',iq,
+!    &             tracers(iq)%nqChildren
       
       ijb=ij_begin-2*iip1
@@ -767,5 +766,5 @@
 c$OMP END DO NOWAIT
       enddo
-      do ifils=1,tracers(iq)%nqChilds
+      do ifils=1,tracers(iq)%nqChildren
         iq2=tracers(iq)%iqDescen(ifils)
         !write(lunout,*) 'vly: appel recursiv vly iq2=',iq2
Index: LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/wrgrads.F
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/wrgrads.F	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/wrgrads.F	(revision 4482)
@@ -76,6 +76,5 @@
            print*,'nvar  ',nvar(if)
            print*,'vars ',(var(iv,if),iv=1,nvar(if))
-
-           stop
+           CALL abort_gcm("wrgrads","problem",1)
          endif
       endif
Index: LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/calfis.F
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/calfis.F	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/calfis.F	(revision 4482)
@@ -186,5 +186,5 @@
          write(lunout,*) '  ngridmx  jjm   iim   '
          write(lunout,*) ngridmx,jjm,iim
-         STOP
+         call abort_gcm("calfis", "", 1)
         ENDIF
       ELSE
Index: LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/calfis_loc.F
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/calfis_loc.F	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/calfis_loc.F	(revision 4482)
@@ -262,5 +262,5 @@
           write(lunout,*) '  ngridmx  jjm   iim   ' 
           write(lunout,*) ngridmx,jjm,iim
-          STOP
+          call abort_gcm("calfis_loc", "", 1)
         ENDIF
 c$OMP MASTER
@@ -1218,7 +1218,6 @@
 
 #else 
-      write(lunout,*) 
-     & "calfis_p: for now can only work with parallel physics" 
-      stop 
+      call abort_gcm("calfis_loc",
+     & "calfis_p: for now can only work with parallel physics", 1)
 #endif 
 ! of #ifdef CPP_PHYS
Index: LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/gr_dyn_fi.F
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/gr_dyn_fi.F	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/gr_dyn_fi.F	(revision 4482)
@@ -22,5 +22,7 @@
 c   -------
 
-      IF(ngrid.NE.2+(jm-2)*(im-1)) STOP 'probleme de dim'
+      IF (ngrid.NE.2+(jm-2)*(im-1)) then
+         call abort_gcm("gr_dyn_fi", 'probleme de dim', 1)
+      end if
 c   traitement des poles
       CALL SCOPY(nfield,pdyn,im*jm,pfi,ngrid)
Index: LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/inigeomphy_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/inigeomphy_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/inigeomphy_mod.F90	(revision 4482)
@@ -25,5 +25,5 @@
   USE nrtype, ONLY: pi
   USE comvert_mod, ONLY: preff, ap, bp, aps, bps, presnivs, &
-                         scaleheight, pseudoalt
+                         scaleheight, pseudoalt, presinter
   USE vertical_layers_mod, ONLY: init_vertical_layers
   IMPLICIT NONE
@@ -233,5 +233,5 @@
   ! copy over preff , ap(), bp(), etc 
   CALL init_vertical_layers(nlayer,preff,scaleheight, &
-                            ap,bp,aps,bps,presnivs,pseudoalt)
+                            ap,bp,aps,bps,presnivs,presinter,pseudoalt)
 
 !$OMP END PARALLEL
Index: LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/ce0l.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/ce0l.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/ce0l.F90	(revision 4482)
@@ -23,5 +23,5 @@
   USE netcdf,         ONLY: NF90_OPEN, NF90_NOWRITE, NF90_CLOSE, NF90_NOERR,    &
          NF90_INQUIRE_DIMENSION, NF90_INQ_DIMID, NF90_INQ_VARID, NF90_GET_VAR
-  USE infotrac,       ONLY: type_trac, infotrac_init
+  USE infotrac,       ONLY: init_infotrac
   USE dimphy,         ONLY: klon
   USE test_disvert_m, ONLY: test_disvert
@@ -108,5 +108,5 @@
   calnd='gregorian'
   SELECT CASE(calend)
-    CASE('earth_360d');CALL ioconf_calendar('360d');   calnd='with 360 days/year'
+    CASE('earth_360d');CALL ioconf_calendar('360_day');   calnd='with 360 days/year'
     CASE('earth_365d');CALL ioconf_calendar('noleap'); calnd='with no leap year'
     CASE('earth_366d');CALL ioconf_calendar('366d');   calnd='with leap years only'
@@ -132,5 +132,5 @@
 
 !--- Tracers initializations
-  CALL infotrac_init()
+  CALL init_infotrac()
 
   CALL inifilr()
Index: LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 4482)
@@ -16,5 +16,5 @@
   USE mod_phys_lmdz_para, ONLY: klon_omp ! number of columns (on local omp grid)
   USE vertical_layers_mod, ONLY : init_vertical_layers
-  USE infotrac, ONLY: nbtr,nqCO2,tracers,isotopes,type_trac,conv_flg,pbl_flg,nqtottr
+  USE infotrac, ONLY: nbtr, type_trac
 #ifdef CPP_StratAer
   USE infotrac_phy, ONLY: nbtr_bin, nbtr_sulgas, id_OCS_strat, &
@@ -30,5 +30,5 @@
   USE mod_phys_lmdz_omp_data, ONLY: klon_omp
 #endif
-  USE control_mod, ONLY: dayref,anneeref,day_step,nday,offline, iphysiq, config_inca
+  USE control_mod, ONLY: dayref,anneeref,day_step,nday,offline, iphysiq
   USE inifis_mod, ONLY: inifis
   USE time_phylmdz_mod, ONLY: init_time
@@ -137,5 +137,5 @@
 
   ! Initialize tracer names, numbers, etc. for physics
-  CALL init_infotrac_phy(type_trac, tracers, isotopes, nqtottr, nqCO2, pbl_flg, conv_flg)
+  CALL init_infotrac_phy
 
   ! Initializations for Reprobus
@@ -166,5 +166,5 @@
   END IF
 
-  IF (type_trac == 'inca' .OR. type_trac == 'inco') THEN
+  IF (ANY(type_trac == ['inca','inco'])) THEN
 #ifdef INCA
      CALL init_inca_dim_reg(nbp_lon, nbp_lat - 1, &
Index: LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/init_ssrf_m.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/init_ssrf_m.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/init_ssrf_m.F90	(revision 4482)
@@ -3,12 +3,13 @@
 !*******************************************************************************
 
-  USE indice_sol_mod, ONLY: is_ter, is_oce, is_oce, is_lic, epsfra
+  USE indice_sol_mod,     ONLY: is_ter, is_oce, is_oce, is_lic, epsfra
   USE dimphy,             ONLY: klon, zmasq
   USE phys_state_var_mod, ONLY: pctsrf
-  USE geometry_mod, ONLY : longitude_deg, latitude_deg
+  USE geometry_mod,       ONLY : longitude_deg, latitude_deg
   USE grid_atob_m,        ONLY: grille_m
   USE ioipsl,             ONLY: flininfo, flinopen, flinget, flinclo
   USE ioipsl_getin_p_mod, ONLY: getin_p
-  USE comconst_mod, ONLY: im, pi
+  USE comconst_mod,       ONLY: im, pi
+  USE surface_data,       ONLY: landice_opt
 
   CHARACTER(LEN=256), PARAMETER :: icefname="landiceref.nc", icevar="landice"
@@ -58,64 +59,75 @@
 ! Sub-surfaces initialization
 !*******************************************************************************
-!--- Read and interpolate on model T-grid soil fraction and soil ice fraction.
-  CALL flininfo(icefname, iml_lic, jml_lic, llm_tmp, ttm_tmp, fid)
-  ALLOCATE(lat_lic(iml_lic,jml_lic),lon_lic(iml_lic,jml_lic))
-  ALLOCATE(fraclic(iml_lic,jml_lic))
-  CALL flinopen(icefname, .FALSE., iml_lic, jml_lic, llm_tmp,  &
- &               lon_lic, lat_lic, lev, ttm_tmp, itaul, date, dt, fid)
-  CALL flinget(fid, icevar, iml_lic, jml_lic, llm_tmp, ttm_tmp, 1,1, fraclic)
-  CALL flinclo(fid)
-  WRITE(lunout,*)'landice dimensions: iml_lic, jml_lic : ',iml_lic,jml_lic
+  IF (landice_opt .LT. 2) THEN
+     ! Continue with reading landice.nc file
+     WRITE(lunout,*)"Read landice.nc file to attribute is_lic fraction"
 
-  ALLOCATE(dlon_lic(iml_lic),dlat_lic(jml_lic))
-  dlon_lic(:)=lon_lic(:,1); IF(MAXVAL(dlon_lic)>pi) dlon_lic=dlon_lic*pi/180.
-  dlat_lic(:)=lat_lic(1,:); IF(MAXVAL(dlat_lic)>pi) dlat_lic=dlat_lic*pi/180.
-  DEALLOCATE(lon_lic,lat_lic); ALLOCATE(flic_tmp(iip1,jjp1))
-  CALL grille_m(dlon_lic,dlat_lic,fraclic,rlonv(1:iim),rlatu,flic_tmp(1:iim,:))
-  flic_tmp(iip1,:)=flic_tmp(1,:)
-
-!--- To the physical grid
-  pctsrf(:,:) = 0.
-  CALL gr_dyn_fi(1, iip1, jjp1, klon, flic_tmp, pctsrf(:,is_lic))
-  DEALLOCATE(flic_tmp)
-
-!--- Adequation with soil/sea mask
-  WHERE(pctsrf(:,is_lic)<EPSFRA) pctsrf(:,is_lic)=0. 
-  WHERE(zmasq(:)<EPSFRA)         pctsrf(:,is_lic)=0.
-  pctsrf(:,is_ter)=zmasq(:)
-  DO ji=1,klon
-    IF(zmasq(ji)>EPSFRA) THEN 
-      IF(pctsrf(ji,is_lic)>=zmasq(ji)) THEN
-        pctsrf(ji,is_lic)=zmasq(ji)
-        pctsrf(ji,is_ter)=0.
-      ELSE
-        pctsrf(ji,is_ter)=zmasq(ji)-pctsrf(ji,is_lic)
-        IF(pctsrf(ji,is_ter)<EPSFRA) THEN
-          pctsrf(ji,is_ter)=0.
-          pctsrf(ji,is_lic)=zmasq(ji)
-        END IF 
-      END IF 
-    END IF 
-  END DO 
-
-
-  !--- Option no_ter_antartique removes all land fractions souther than 60S.
-  !--- Land ice is set instead of the land fractions on these latitudes.
-  !--- The ocean and sea-ice fractions are not changed.
-  no_ter_antartique=.FALSE.
-  CALL getin_p('no_ter_antartique',no_ter_antartique)
-  WRITE(lunout,*)"no_ter_antartique=",no_ter_antartique
-  IF (no_ter_antartique) THEN
-     ! Remove all land fractions souther than 60S and set land-ice instead
-     WRITE(lunout,*) "Remove land fractions souther than 60deg south by increasing"
-     WRITE(lunout,*) "the continental ice fractions. No land can now be found at Antartic."
-     DO ji=1, klon
-        IF (latitude_deg(ji)<-60.0) THEN
-           pctsrf(ji,is_lic) = pctsrf(ji,is_lic) + pctsrf(ji,is_ter)
-           pctsrf(ji,is_ter) = 0
+     !--- Read and interpolate on model T-grid soil fraction and soil ice fraction.
+     CALL flininfo(icefname, iml_lic, jml_lic, llm_tmp, ttm_tmp, fid)
+     ALLOCATE(lat_lic(iml_lic,jml_lic),lon_lic(iml_lic,jml_lic))
+     ALLOCATE(fraclic(iml_lic,jml_lic))
+     CALL flinopen(icefname, .FALSE., iml_lic, jml_lic, llm_tmp,  &
+          &               lon_lic, lat_lic, lev, ttm_tmp, itaul, date, dt, fid)
+     CALL flinget(fid, icevar, iml_lic, jml_lic, llm_tmp, ttm_tmp, 1,1, fraclic)
+     CALL flinclo(fid)
+     WRITE(lunout,*)'landice dimensions: iml_lic, jml_lic : ',iml_lic,jml_lic
+     
+     ALLOCATE(dlon_lic(iml_lic),dlat_lic(jml_lic))
+     dlon_lic(:)=lon_lic(:,1); IF(MAXVAL(dlon_lic)>pi) dlon_lic=dlon_lic*pi/180.
+     dlat_lic(:)=lat_lic(1,:); IF(MAXVAL(dlat_lic)>pi) dlat_lic=dlat_lic*pi/180.
+     DEALLOCATE(lon_lic,lat_lic); ALLOCATE(flic_tmp(iip1,jjp1))
+     CALL grille_m(dlon_lic,dlat_lic,fraclic,rlonv(1:iim),rlatu,flic_tmp(1:iim,:))
+     flic_tmp(iip1,:)=flic_tmp(1,:)
+     
+     !--- To the physical grid
+     pctsrf(:,:) = 0.
+     CALL gr_dyn_fi(1, iip1, jjp1, klon, flic_tmp, pctsrf(:,is_lic))
+     DEALLOCATE(flic_tmp)
+     
+     !--- Adequation with soil/sea mask
+     WHERE(pctsrf(:,is_lic)<EPSFRA) pctsrf(:,is_lic)=0. 
+     WHERE(zmasq(:)<EPSFRA)         pctsrf(:,is_lic)=0.
+     pctsrf(:,is_ter)=zmasq(:)
+     DO ji=1,klon
+        IF(zmasq(ji)>EPSFRA) THEN 
+           IF(pctsrf(ji,is_lic)>=zmasq(ji)) THEN
+              pctsrf(ji,is_lic)=zmasq(ji)
+              pctsrf(ji,is_ter)=0.
+           ELSE
+              pctsrf(ji,is_ter)=zmasq(ji)-pctsrf(ji,is_lic)
+              IF(pctsrf(ji,is_ter)<EPSFRA) THEN
+                 pctsrf(ji,is_ter)=0.
+                 pctsrf(ji,is_lic)=zmasq(ji)
+              END IF
+           END IF
         END IF
      END DO
+     
+     
+     !--- Option no_ter_antartique removes all land fractions souther than 60S.
+     !--- Land ice is set instead of the land fractions on these latitudes.
+     !--- The ocean and sea-ice fractions are not changed.
+     no_ter_antartique=.FALSE.
+     CALL getin_p('no_ter_antartique',no_ter_antartique)
+     WRITE(lunout,*)"no_ter_antartique=",no_ter_antartique
+     IF (no_ter_antartique) THEN
+        ! Remove all land fractions souther than 60S and set land-ice instead
+        WRITE(lunout,*) "Remove land fractions souther than 60deg south by increasing"
+        WRITE(lunout,*) "the continental ice fractions. No land can now be found at Antartic."
+        DO ji=1, klon
+           IF (latitude_deg(ji)<-60.0) THEN
+              pctsrf(ji,is_lic) = pctsrf(ji,is_lic) + pctsrf(ji,is_ter)
+              pctsrf(ji,is_ter) = 0
+           END IF
+        END DO
+     END IF
+     
+  ELSE
+     ! landice_opt=2 and higher
+     WRITE(lunout,*) 'No landice is attributed is_lic sub-surface because landice_opt=2 or higher.'
+     WRITE(lunout,*) 'This means that the land model will handel land ice as well as all other land areas.'
+     pctsrf(:,is_ter) = zmasq(:)
+     pctsrf(:,is_lic) = 0.0
   END IF
-
 
 !--- Sub-surface ocean and sea ice (sea ice set to zero for start).
Index: LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/limit_netcdf.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/limit_netcdf.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/limit_netcdf.F90	(revision 4482)
@@ -424,5 +424,5 @@
   IF(NF90_GET_ATT(ncid, varid, 'calendar', cal_in)/=NF90_NOERR) THEN
     SELECT CASE(mode)
-      CASE('RUG', 'ALB'); cal_in='360d'
+      CASE('RUG', 'ALB'); cal_in='360_day'
       CASE('SIC', 'SST'); cal_in='gregorian'
     END SELECT
@@ -492,5 +492,5 @@
       !--- DROPPED FOR BCS DATA (FRACTIONS CAN BE HIGHER THAN 1)
       IF(ll.AND.ix_sic/=1.AND.mode=='SIC') &
-        CALL abort_physic(mode,'unrealistic '//TRIM(mode)//' found: '//TRIM(str))
+        CALL abort_physic(mode,'unrealistic '//TRIM(mode)//' found: '//TRIM(str), 1)
 
     END IF
@@ -599,5 +599,5 @@
          CALL pchfe_95(timeyear, champtime(i, j, :), yder, skip, &
               arth(0.5, real(ndays_in) / ndays, ndays), champan(i, j, :), ierr)
-         if (ierr < 0) stop 1
+         if (ierr < 0) call abort_physic("get_2Dfield", "", 1)
          n_extrap = n_extrap + ierr
        END DO
@@ -641,5 +641,5 @@
   ALLOCATE(champo(klon, ndays))
   DO k=1, ndays
-    CALL gr_dyn_fi(1, iip1, jjp1, klon, champan(1, 1, k), champo(1, k))
+    CALL gr_dyn_fi(1, iip1, jjp1, klon, champan(1, 1, k), champo(:, k))
   END DO
   DEALLOCATE(champan)
Index: LMDZ6/branches/LMDZ_ECRad/libf/filtrez/filtreg.F
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/filtrez/filtreg.F	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/filtrez/filtreg.F	(revision 4482)
@@ -71,4 +71,6 @@
 
       INTEGER :: sdd1_type, sdd2_type
+
+      if ( iim == 1 ) return ! no filtre in 2D y-z
 
       IF (first) THEN
Index: LMDZ6/branches/LMDZ_ECRad/libf/filtrez/filtreg_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/filtrez/filtreg_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/filtrez/filtreg_mod.F90	(revision 4482)
@@ -66,4 +66,5 @@
     !-----------------------------------------------------------
     !
+    if ( iim == 1 ) return ! No filtre in 2D y-z
 
     pi       = 2. * ASIN( 1. )
@@ -125,4 +126,5 @@
     !
     colat0  =  MIN( 0.5, dymin/dxmin )
+    ! colat0  =  1.
     !
     IF( .NOT.fxyhypb.AND.ysinus )  THEN
Index: LMDZ6/branches/LMDZ_ECRad/libf/filtrez/mod_fft_wrapper.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/filtrez/mod_fft_wrapper.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/filtrez/mod_fft_wrapper.F90	(revision 4482)
@@ -11,5 +11,6 @@
     INTEGER :: nb
     
-    STOP "wrapper fft : une FFT doit etre specifiee a l'aide d'une clee CPP, sinon utiliser le filtre classique"
+    print *, "wrapper fft : une FFT doit etre specifiee a l'aide d'une clee CPP, sinon utiliser le filtre classique"
+    stop 1
   END SUBROUTINE Init_fft
   
@@ -21,5 +22,6 @@
     COMPLEX,INTENT(INOUT) :: TF_vect(vsize/2+1,nb_vect)
     
-    STOP "wrapper fft : une FFT doit etre specifiee a l'aide d'une clee CPP, sinon utiliser le filtre classique"
+    print *, "wrapper fft : une FFT doit etre specifiee a l'aide d'une clee CPP, sinon utiliser le filtre classique"
+    stop 1
     
   END SUBROUTINE fft_forward
@@ -31,5 +33,6 @@
     COMPLEX,INTENT(IN ) :: TF_vect(vsize/2+1,nb_vect)
   
-    STOP "wrapper fft : une FFT doit etre specifiee a l'aide d'une clee CPP, sinon utiliser le filtre classique"
+    print *, "wrapper fft : une FFT doit etre specifiee a l'aide d'une clee CPP, sinon utiliser le filtre classique"
+    stop 1
     
   END SUBROUTINE fft_backward
Index: LMDZ6/branches/LMDZ_ECRad/libf/grid/dimension/makdim
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/grid/dimension/makdim	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/grid/dimension/makdim	(revision 4482)
@@ -12,5 +12,5 @@
 fi
 
-if (($1 % 8 != 0)) && (( $# == 3 ))
+if ( ( ($1 % 8 != 0)) && (( $# == 3 ) ) || ( $1 == 1 ) )
 then
     echo "The number of longitudes must be a multiple of 8."
